/*	$NetBSD: prop_object_impl.h,v 1.12 2007/03/12 18:18:39 ad Exp $	*/

/*-
 * Copyright (c) 2007 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Jachym Holecek <freza@NetBSD.org>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the NetBSD
 *      Foundation, Inc. and its contributors.
 * 4. Neither the name of The NetBSD Foundation nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PROPLIB_PROP_CODEC_IMPL_H_
#define _PROPLIB_PROP_CODEC_IMPL_H_

struct _prop_codec {
	const char 	*codec_name;
	const u_char 	*codec_sense;

	/* Either we provide direct backends for public functions. */
	char * 		(*codec_dictionary_externalize)(prop_dictionary_t);
	char * 		(*codec_array_externalize)(prop_array_t);
	prop_dictionary_t (*codec_dictionary_internalize)(const char *);
	prop_array_t 	(*codec_array_internalize)(const char *);

	/* Or we provide "stream-friendly" API and emulate the above. */
	char * 		(*codec_externalize_compound)(prop_object_t);
	int 		(*codec_parser_create)(prop_parser_t *);
	int 		(*codec_parser_exec)(prop_parser_t, const u_char *,
			    size_t);
	prop_object_t 	(*codec_parser_yield)(prop_parser_t);
	void 		(*codec_parser_destroy)(prop_parser_t);
};

#endif /* _PROPLIB_PROP_CODEC_IMPL_H_ */
